#include <gtk/gtk.h>
#include <time.h>
#include <sys/types.h> 
#include <esd.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

gint update_clock();
void talk();

gint delete_event(GtkWidget *widget,GdkEvent *event,gpointer data)
{
  /* False = destroy
     Return true for you sure prompts */
  return FALSE;
} // end delete event

void destroy(GtkWidget *widget,gpointer data)
{

  //play sound
  //  int ESD;
  esd_play_file("BYE","test.wav",1);

  gtk_main_quit();
} // end destroy event




//Globals
static GtkWidget *time_label;
int main( int argc, char *argv[])

{

  //declare widgets
  GtkWidget *window;
  GtkWidget *talk_button;

  GtkWidget *box1;


  gtk_init (&argc, &argv);

  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

  //close on X check
 g_signal_connect(G_OBJECT(window),"destroy",G_CALLBACK(destroy),NULL);

 // close on wm close
 g_signal_connect(G_OBJECT(window),"delete_event",G_CALLBACK(delete_event),NULL);

 // set window properties
 gtk_container_set_border_width(GTK_CONTAINER (window),10);
 gtk_window_set_title(GTK_WINDOW(window),"Talking Clock");


 //pack box into window
 box1=gtk_hbox_new (FALSE,0);
 gtk_container_add(GTK_CONTAINER(window),box1);

 // talk button
 talk_button = gtk_button_new_with_label("Talk");
 gtk_box_pack_start (GTK_BOX(box1),talk_button,TRUE,TRUE,0);
  //close on X check
 g_signal_connect(G_OBJECT(talk_button),"clicked",G_CALLBACK(talk),NULL);



 //time label
 time_label=gtk_label_new("Time Here");
 gtk_box_pack_start (GTK_BOX(box1),time_label,TRUE,TRUE,0);
 update_clock();

 //1 sec interval
gtk_timeout_add(1000,(GtkFunction)update_clock,NULL);


 //show
 gtk_widget_show(talk_button);
 gtk_widget_show(time_label);
 gtk_widget_show(box1);
  gtk_widget_show (window);





int pid; /* process identifier */
 
pid = fork();
if ( pid < 0 )
		 { printf("Cannot fork!!$\backslash$n");
		 }

if ( pid == 0 )	 {  /* Child process */
		   //play sound
  esd_play_file("DACLOCK","DACLOCK.WAV",1);
  exit(0);
} 


  gtk_main();

  return(0);

}


gint update_clock() {

time_t now = time(0);
// get hour
 struct tm mytime;
 mytime = *localtime(&now);
 char clock_display[100];

 // 12 hour format
 if (mytime.tm_hour > 12) {mytime.tm_hour = mytime.tm_hour - 12;}

sprintf(clock_display,"%d:%d",mytime.tm_hour,mytime.tm_min);


  gtk_label_set_text(GTK_LABEL(time_label),clock_display);


  return 1;} // end undate clock

void talk (GtkWidget *widget,gpointer data) {

time_t now = time(0);
// get hour
 struct tm mytime;
 mytime = *localtime(&now);
 char clock_display[100];

 // hours

// 12 hour format
 if (mytime.tm_hour > 12) {mytime.tm_hour = mytime.tm_hour - 12;}


sprintf(clock_display,"%d.WAV",mytime.tm_hour);


  //play sound
  esd_play_file("hour",clock_display,1);
  sleep(1);

  //minutes

  // play O if less than 10
if (mytime.tm_min <= 9) {
  sprintf(clock_display,"0.WAV");
  esd_play_file("min",clock_display,1);} // end min less than= 20




if (mytime.tm_min <= 20) {
  sprintf(clock_display,"%d.WAV",mytime.tm_min);
  esd_play_file("min",clock_display,1);} // end min less than= 20
 else {sprintf(clock_display,"%d0.WAV",mytime.tm_min/10);
esd_play_file("min tens",clock_display,1);
 sleep(1);
// snigles digits
sprintf(clock_display,"%d",mytime.tm_min);
 clock_display[0]=clock_display[1];
 clock_display[1]='\0';
 strcat (clock_display,".WAV");
esd_play_file("min singles",clock_display,1);

}
  

  //AM PM
 sleep(1);
  now = time(0);
  mytime = *localtime(&now);
  if (mytime.tm_hour > 12) {sprintf(clock_display,"PM.WAV");
  esd_play_file("min",clock_display,1); }

} // end talk
